// Auto-generated. Do not edit!

// (in-package wireless_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class Connection {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.bitrate = null;
      this.txpower = null;
      this.link_quality_raw = null;
      this.link_quality = null;
      this.signal_level = null;
      this.noise_level = null;
      this.essid = null;
      this.bssid = null;
      this.frequency = null;
    }
    else {
      if (initObj.hasOwnProperty('bitrate')) {
        this.bitrate = initObj.bitrate
      }
      else {
        this.bitrate = 0.0;
      }
      if (initObj.hasOwnProperty('txpower')) {
        this.txpower = initObj.txpower
      }
      else {
        this.txpower = 0;
      }
      if (initObj.hasOwnProperty('link_quality_raw')) {
        this.link_quality_raw = initObj.link_quality_raw
      }
      else {
        this.link_quality_raw = '';
      }
      if (initObj.hasOwnProperty('link_quality')) {
        this.link_quality = initObj.link_quality
      }
      else {
        this.link_quality = 0.0;
      }
      if (initObj.hasOwnProperty('signal_level')) {
        this.signal_level = initObj.signal_level
      }
      else {
        this.signal_level = 0;
      }
      if (initObj.hasOwnProperty('noise_level')) {
        this.noise_level = initObj.noise_level
      }
      else {
        this.noise_level = 0;
      }
      if (initObj.hasOwnProperty('essid')) {
        this.essid = initObj.essid
      }
      else {
        this.essid = '';
      }
      if (initObj.hasOwnProperty('bssid')) {
        this.bssid = initObj.bssid
      }
      else {
        this.bssid = '';
      }
      if (initObj.hasOwnProperty('frequency')) {
        this.frequency = initObj.frequency
      }
      else {
        this.frequency = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Connection
    // Serialize message field [bitrate]
    bufferOffset = _serializer.float32(obj.bitrate, buffer, bufferOffset);
    // Serialize message field [txpower]
    bufferOffset = _serializer.int16(obj.txpower, buffer, bufferOffset);
    // Serialize message field [link_quality_raw]
    bufferOffset = _serializer.string(obj.link_quality_raw, buffer, bufferOffset);
    // Serialize message field [link_quality]
    bufferOffset = _serializer.float32(obj.link_quality, buffer, bufferOffset);
    // Serialize message field [signal_level]
    bufferOffset = _serializer.int16(obj.signal_level, buffer, bufferOffset);
    // Serialize message field [noise_level]
    bufferOffset = _serializer.int16(obj.noise_level, buffer, bufferOffset);
    // Serialize message field [essid]
    bufferOffset = _serializer.string(obj.essid, buffer, bufferOffset);
    // Serialize message field [bssid]
    bufferOffset = _serializer.string(obj.bssid, buffer, bufferOffset);
    // Serialize message field [frequency]
    bufferOffset = _serializer.float64(obj.frequency, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Connection
    let len;
    let data = new Connection(null);
    // Deserialize message field [bitrate]
    data.bitrate = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [txpower]
    data.txpower = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [link_quality_raw]
    data.link_quality_raw = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [link_quality]
    data.link_quality = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [signal_level]
    data.signal_level = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [noise_level]
    data.noise_level = _deserializer.int16(buffer, bufferOffset);
    // Deserialize message field [essid]
    data.essid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [bssid]
    data.bssid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [frequency]
    data.frequency = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.link_quality_raw.length;
    length += object.essid.length;
    length += object.bssid.length;
    return length + 34;
  }

  static datatype() {
    // Returns string type for a message object
    return 'wireless_msgs/Connection';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f1a0d060cec0bda21949621526aa056e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    float32 bitrate  # Mb/s
    int16 txpower  # dBm
    
    # Fractional link quality number preserved in raw
    # field, resolved to decimal for link_quality field.
    string link_quality_raw
    float32 link_quality
    
    int16 signal_level  # dBm
    int16 noise_level  # dBm
    
    string essid
    string bssid
    float64 frequency
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Connection(null);
    if (msg.bitrate !== undefined) {
      resolved.bitrate = msg.bitrate;
    }
    else {
      resolved.bitrate = 0.0
    }

    if (msg.txpower !== undefined) {
      resolved.txpower = msg.txpower;
    }
    else {
      resolved.txpower = 0
    }

    if (msg.link_quality_raw !== undefined) {
      resolved.link_quality_raw = msg.link_quality_raw;
    }
    else {
      resolved.link_quality_raw = ''
    }

    if (msg.link_quality !== undefined) {
      resolved.link_quality = msg.link_quality;
    }
    else {
      resolved.link_quality = 0.0
    }

    if (msg.signal_level !== undefined) {
      resolved.signal_level = msg.signal_level;
    }
    else {
      resolved.signal_level = 0
    }

    if (msg.noise_level !== undefined) {
      resolved.noise_level = msg.noise_level;
    }
    else {
      resolved.noise_level = 0
    }

    if (msg.essid !== undefined) {
      resolved.essid = msg.essid;
    }
    else {
      resolved.essid = ''
    }

    if (msg.bssid !== undefined) {
      resolved.bssid = msg.bssid;
    }
    else {
      resolved.bssid = ''
    }

    if (msg.frequency !== undefined) {
      resolved.frequency = msg.frequency;
    }
    else {
      resolved.frequency = 0.0
    }

    return resolved;
    }
};

module.exports = Connection;
